Index: /trunk/sources/HeuristicLab.DebugEngine/3.3/ExecutionStackView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DebugEngine/3.3/ExecutionStackView.cs	(revision 5145)
+++ /trunk/sources/HeuristicLab.DebugEngine/3.3/ExecutionStackView.cs	(revision 5146)
@@ -81,4 +81,5 @@
         treeView.ImageList.Images.Add(VS2008ImageLibrary.Method);
         treeView.ImageList.Images.Add(VS2008ImageLibrary.Module);
+        treeView.ImageList.Images.Add(VS2008ImageLibrary.BreakpointActive);
         int totalNodes = AddStackOperations(treeView.Nodes, ((IEnumerable<IOperation>)Content).Reverse());
         if (treeView.Nodes.Count > 0)
@@ -111,8 +112,12 @@
             Utils.TypeName(atom.Operator), Environment.NewLine,
             Utils.Wrap(atom.Operator.Description ?? atom.Operator.ItemDescription, 60));
-          node.ImageIndex = 0;
-          node.SelectedImageIndex = 0;
-          if (atom.Operator.Breakpoint)
+          if (atom.Operator.Breakpoint) {
             node.ForeColor = Color.Red;
+            node.ImageIndex = 2;
+            node.SelectedImageIndex = 2;
+          } else {
+            node.ImageIndex = 0;
+            node.SelectedImageIndex = 0;
+          }
           count++;
         } else if (op is OperationCollection) {
Index: /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContent.cs
===================================================================
--- /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContent.cs	(revision 5145)
+++ /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContent.cs	(revision 5146)
@@ -20,5 +20,7 @@
 #endregion
 
+using System.Drawing;
 using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 
@@ -31,4 +33,5 @@
     public ExecutionContext ExecutionContext { get; private set; }
     public string Name { get; private set; }
+    public Image Icon { get; private set; }
 
     public OperationContent(IOperation operation) {
@@ -39,8 +42,15 @@
       if (AtomicOperation != null) {
         Name = Utils.Name(AtomicOperation);
+        if (AtomicOperation.Operator != null && AtomicOperation.Operator.Breakpoint) {
+          Icon = VS2008ImageLibrary.BreakpointActive;
+        } else {
+          Icon = VS2008ImageLibrary.Method;
+        }
       } else if (Collection != null) {
         Name = string.Format("{0} Operations", Collection.Count);
+        Icon = VS2008ImageLibrary.Module;
       } else {
         Name = "";
+        Icon = VS2008ImageLibrary.Nothing;
       }
     }
Index: /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContentView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContentView.Designer.cs	(revision 5145)
+++ /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContentView.Designer.cs	(revision 5146)
@@ -58,4 +58,5 @@
       this.nameTextBox = new System.Windows.Forms.TextBox();
       this.parametersImageList = new System.Windows.Forms.ImageList(this.components);
+      this.iconBox = new System.Windows.Forms.PictureBox();
       this.groupBox.SuspendLayout();
       this.splitContainer1.Panel1.SuspendLayout();
@@ -65,8 +66,10 @@
       this.executionContextConextMenu.SuspendLayout();
       this.scopeGroupBox.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.iconBox)).BeginInit();
       this.SuspendLayout();
       // 
       // groupBox
       // 
+      this.groupBox.Controls.Add(this.iconBox);
       this.groupBox.Controls.Add(this.splitContainer1);
       this.groupBox.Controls.Add(this.nameTextBox);
@@ -187,8 +190,8 @@
             | System.Windows.Forms.AnchorStyles.Right)));
       this.nameTextBox.Cursor = System.Windows.Forms.Cursors.Default;
-      this.nameTextBox.Location = new System.Drawing.Point(6, 19);
+      this.nameTextBox.Location = new System.Drawing.Point(32, 19);
       this.nameTextBox.Name = "nameTextBox";
       this.nameTextBox.ReadOnly = true;
-      this.nameTextBox.Size = new System.Drawing.Size(551, 20);
+      this.nameTextBox.Size = new System.Drawing.Size(525, 20);
       this.nameTextBox.TabIndex = 3;
       this.nameTextBox.DoubleClick += new System.EventHandler(this.nameTextBox_DoubleClick);
@@ -199,4 +202,12 @@
       this.parametersImageList.ImageSize = new System.Drawing.Size(16, 16);
       this.parametersImageList.TransparentColor = System.Drawing.Color.Transparent;
+      // 
+      // iconBox
+      // 
+      this.iconBox.Location = new System.Drawing.Point(6, 19);
+      this.iconBox.Name = "iconBox";
+      this.iconBox.Size = new System.Drawing.Size(20, 20);
+      this.iconBox.TabIndex = 5;
+      this.iconBox.TabStop = false;
       // 
       // OperationContentView
@@ -215,4 +226,5 @@
       this.executionContextConextMenu.ResumeLayout(false);
       this.scopeGroupBox.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.iconBox)).EndInit();
       this.ResumeLayout(false);
 
@@ -233,4 +245,5 @@
     private System.Windows.Forms.ContextMenuStrip executionContextConextMenu;
     private System.Windows.Forms.ToolStripMenuItem showValueToolStripMenuItem;
+    private System.Windows.Forms.PictureBox iconBox;
   }
 }
Index: /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContentView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContentView.cs	(revision 5145)
+++ /trunk/sources/HeuristicLab.DebugEngine/3.3/OperationContentView.cs	(revision 5146)
@@ -50,8 +50,10 @@
         scopeTreeView.Nodes.Clear();
         executionContextTreeView.Nodes.Clear();
+        iconBox.Image = null;
       } else {
         nameTextBox.Text = Content.Name;
         UpdateScopeTree();
         UpdateExecutionContext();
+        iconBox.Image = Content.Icon;
       }
     }
Index: /trunk/sources/HeuristicLab.DebugEngine/3.3/OperatorTraceView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DebugEngine/3.3/OperatorTraceView.cs	(revision 5145)
+++ /trunk/sources/HeuristicLab.DebugEngine/3.3/OperatorTraceView.cs	(revision 5146)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Drawing;
 using System.Windows.Forms;
 using HeuristicLab.Collections;
@@ -77,4 +78,5 @@
       listView.SmallImageList.Images.Add(VS2008ImageLibrary.Method);
       listView.SmallImageList.Images.Add(VS2008ImageLibrary.Module);
+      listView.SmallImageList.Images.Add(VS2008ImageLibrary.BreakpointActive);
       foreach (var item in Content) {
         var viewItem = listView.Items.Add(item.Name ?? item.ItemName);
@@ -83,5 +85,10 @@
           Utils.Wrap(item.Description, 60));
         viewItem.Tag = item;
-        viewItem.ImageIndex = item is CombinedOperator ? 1 : 0;
+        if (item.Breakpoint) {
+          viewItem.ForeColor = Color.Red;
+          viewItem.ImageIndex = 2;
+        } else {
+          viewItem.ImageIndex = item is CombinedOperator ? 1 : 0;
+        }
       }
       if (listView.Items.Count > 0) {